/*************************************/
/* Utility subroutines for Argon 2.0 */
/*************************************/

#ifndef _UTILS_H
#define _UTILS_H

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>

double frandom();
void randnorm (int n, double x[]);
int freetowrite (char filename[]);
void waitfor (double seconds);
double watch (char token[], int command);
char *earth_time (double seconds);
void matran (double A[3][3], double B[3][3]);
void matadd (double A[3][3], double B[3][3], double C[3][3]);
void matsub (double A[3][3], double B[3][3], double C[3][3]);
void matmul (double A[3][3], double B[3][3], double C[3][3]);
double matinv (double A[3][3], double B[3][3]);
char *diag3 (double A[3][3], double eigval[3], double Q[3][3]);
void quicksort (int n, double arr[], int idx[]);

#endif
